#include <Path.h>
#include <File.h>
#include <FindDirectory.h>
#include <support/UTF8.h>
#include <stdio.h>

#include "LanguageClass.h"

LanguageClass	Language;

LanguageClass::LanguageClass()
		: LList(100) {

	set("NAME", "BeInformed");
	set("VERSION", "V0.9.5");
	set("NAME_VERSION", "BeInformed V0.9.5");
	set("DATE", "25/11/1998");
	set("ABOUT_TEXT",	"Newsclient for BeOS R4/x86\n\nDirk Olbertz\nolbertz@do.isst.fhg.de\n\nNovember, 25th '98\n\nBuild on R4GM");
	set("XNEWSREADER", "BeInformed V0.9.5 [x86]");
	if(!load()){
		set("SORRY", "Sorry");
		set("NOT_YET", "Not implemented yet!");
		set("NEVER_MIND", "Never mind");
		set("SURE_TO_QUIT", "Are you sure to quit?");
		set("ADD_NEW_FILTER", "Create new filter");
		set("WINDOWS", "Window");
		set("HOSTS_WIN", "List of all hosts");
		set("SETTINGS", "Settings");
		set("CLOSE", "Close");
		set("HOSTS", "Hosts");
		set("ASK_ALL_GROUPS", "Ask for all groups");
		set("ASK_NEW_GROUPS", "Ask for new groups");
		set("REMOVE_HOST", "Remove host");
		set("SUBSCRIBE", "Subscribe '%s'");
		set("UNSUBSCRIBE", "Unsubscribe '%s'");
		set("GET_ARTICLE", "Retrieving articles" B_UTF8_ELLIPSIS);
		set("GET_ARTICLE_T", " articles remaining");
		set("SUBSCRIBED_SETTINGS", "Edit settings");
		set("SAVE", "Save");
		set("FILTER_ITEMS", "Filters");
		set("ALL_NEW", "New articles");
		set("ALL_UNREAD", "Unread articles");
		set("ALL_MARKED", "Marked headers");
		set("ALL_QUEUED", "Outgoing articles");
		set("NEWSGROUP_ITEMS", "Newsgroups");
		set("NEWS_MESSAGE", "News-Messages");
		set("POST_NEWS_MESSAGE", "Post new message");
		set("FOLLOWUP_NEWS_MESSAGE", "Followup message");
		set("DEL_TRASH", "Delete articles in Trash");
		set("UNDELETE_SINGLE", "Undelete");
		set("CONVERT", "Convert Messages to V0.9.5" B_UTF8_ELLIPSIS);
	}
	size = LList.CountItems();
}

char *LanguageClass::get(char *pLookUp){
	int	i;
	
	for(i=0; i<size; ++i)
		if(strcasecmp(((lang_struct*)LList.ItemAt(i))->name, pLookUp) == 0)
			return ((lang_struct*)LList.ItemAt(i))->entry;
	
	return strdup(pLookUp);
}

bool LanguageClass::load(){
	BPath	lLoadPath;
	char	*lBuffer,
			*lLine,
			*lFound,
			*lBufferPtr,
			lItem[80],
			lValue[1024];
	off_t	lSize;
	ssize_t	lBytesRead;
	BFile	*lFile;
	bool	lReturnValue;
	
	lFile = 0;
	lReturnValue = false;
	lSize = 0;
				
	find_directory(B_USER_SETTINGS_DIRECTORY, &lLoadPath);
	lLoadPath.Append("BeInformed");
	lLoadPath.Append(LANGUAGE_FILE);
	lFile = new BFile(lLoadPath.Path(), B_READ_ONLY);
	if(lFile->InitCheck() == B_NO_ERROR){
		lReturnValue = true;
		lFile->GetSize(&lSize);
		lBuffer = new char[lSize+1];
		lBytesRead = lFile->Read(lBuffer, lSize);
		lBuffer[lBytesRead] = '\0';
		lBufferPtr = lBuffer;
		lFound = strstr(lBufferPtr, "\n");
		while(lFound != 0){
			*lFound = '\0';
			lLine = strdup(lBufferPtr);
			lItem[0] = '\0';
			lValue[0] = '\0';
			if(lLine[0] != ';'){
				sscanf(lLine, "%s = %s", &lItem, &lValue);
				if(strlen(lItem) > 0){
					char	*lK1, 
							*lK2;
					int		lI;
							
					lK1 = strstr(lLine, "{");
					lK2 = strstr(lLine, "}");
					for(lI=0; lI<lK2-lK1-1; ++lI){
						if(*(lK1+lI+1) == '\\' && *(lK1+lI+2) == 'n'){
							lValue[lI] = ' ';
							++lI;
							lValue[lI] = '\n';
						} else if(*(lK1+lI+1) == '\\' && *(lK1+lI+2) == 't'){
							lValue[lI] = ' ';
							++lI;
							lValue[lI] = '\t';
						} else if(*(lK1+lI+1) == '\\' && *(lK1+lI+2) == 'e'){
							lValue[lI] = B_UTF8_ELLIPSIS;
							++lI;
							lValue[lI] = ' ';
						} else 
							lValue[lI] = *(lK1+lI+1);
					} 
					lValue[lI] = '\0';
					set(lItem, lValue);
				}
			}
			lBufferPtr = lFound + 1;
			lFound = strstr(lBufferPtr, "\n");
		}
		delete [] lBuffer;
	}
	return lReturnValue;
};

void LanguageClass::set(char *pName, char *pEntry, bool pCheck){
	if(pCheck){
	} else {
		LList.AddItem(new lang_struct(pName, pEntry));
	}
}